VisualEditor: Where VisualEditor is the primary editor, redlinks in read mode should open VE (not wikitext editor)
Closed, ResolvedPublic40 Story Points

Details

Reference
bz53441

Related Objects

StatusAssignedTask
OpenNone
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
ResolvedKrenair
DeclinedWhatamidoing-WMF
ResolvedKrenair
ResolvedKrenair
InvalidKrinkle
ResolvedKrenair
ResolvedKrenair
There are a very large number of changes, so older changes are hidden. Show Older Changes

I reported this as a nead to create new page with VE. In this ligt there is a not logic message "you follow the link to the page which does not exist" Basically yes, but I had to do the step out of the page displayed with normal wikitext editing to the different one in VE. Once this bug removed, this can stay.

I am not sure of this change will be beneficial at this point, given that VE is currently still used by minority of users. It might result in more people disabling VE entirely.

Why do you think so? I have a reason, why I set up VE and I am disappointed it doesn not work for creating new pages. Who might be disappointed from using it on VE?

What I meant is that a vocal group of English Wikipedia users hates VisualEditor's guts and would enjoy the new opportunity to spit on it. I hope this clarifies the issue. :)

VisualEditor is also still not quite compatible with some languages and some wikis' conventions, so this would regardless need to be behind a configuration option.

Krinkle removed a subscriber: Krinkle.Dec 17 2014, 6:40 AM
Krinkle added a subscriber: Krinkle.Jan 8 2015, 1:15 PM

I think the editor should initialise at a canonical url. Perhaps with a way to force a specific editor but the vast majority of urls should point to the edit page without making assumptions about what editor that is. This means when we switch the default, existing urls will work as expected.

We already have two different editors for wikitext (classic toolbar and WikiEditor). Though they don't have a way to switch without changing user preferences right now, WikiEditor loads on the old edit page. I think from a user perspective, VisualEditor should be introduced the same way.

action=edit:

  • Would load editor based on user preference. Default user preference being the site default. As with any user preference, this preference can be made immutable or hidden from the preferences page if we don't want it to be per-user.
  • Use &editor=... to force a specific editor. This is what can be used when applications need to interoperate. E.g. in gadgets needing wikitext. Or when VisualEditor submits data to the wikitext editor (though it may incorporate its own wikitext editor). And of course in links like "Edit" / "Edit source". And permalinks (VisualEditor may want to do a pushState to editor=ve once loaded via plain action=edit so that one can share permalinks).

I support not making assumptions about the editor, but I think making action=edit point to VisualEditor would break lots of things.

Jdforrester-WMF lowered the priority of this task from High to Normal.Jan 15 2015, 12:16 AM
Jdforrester-WMF set Security to None.

What I meant is that a vocal group of English Wikipedia users hates VisualEditor's guts and would enjoy the new opportunity to spit on it. I hope this clarifies the issue. :)

VisualEditor is also still not quite compatible with some languages and some wikis' conventions, so this would regardless need to be behind a configuration option.

I thought, they asked to switch it off at all.

Ricordisamoa removed Ricordisamoa as the assignee of this task.Jan 21 2015, 4:34 AM

This has to be discussed further.

@Krenair: should I abandon my patch then?

Are you going to work on it more? I got the impression from the way you unassigned this that we shouldn't review the patch before discussing this further.

I do not plan to work on it before the discussion has an outcome (nor I have any personal interest in supporting VisualEditor at the moment), but the patch is up for anyone who wants to play with it.

Change 178817 abandoned by Ricordisamoa:
Consistent edit links

Reason:
There ain't no such thing as a solution for this.

https://gerrit.wikimedia.org/r/178817

TTO added a subscriber: TTO.May 8 2015, 11:51 AM

This option should (must?) be available for those who wish to use VE on their own MediaWiki installations. Currently, redlinks are a "hole" through which unsuspecting users can "fall" into the "pipework" of the wikitext editor.

Most of the discussion here deals with the social aspects of the task, which doesn't seem hugely relevant here. The functionality would presumably live behind a $wg flag, and be switched off by default.

Change 178817 restored by TTO:
Consistent edit links

Reason:
Seems like a valuable change.

https://gerrit.wikimedia.org/r/178817

When it happens, it'll happen on every wiki. Until then it can't be on any wiki...

Krinkle renamed this task from VisualEditor: Where VisualEditor is the primary editor, redlinks in read mode should go to veaction=edit not action=edit to VisualEditor: Where VisualEditor is the primary editor, redlinks in read mode should open VE (not wikitext editor).Jun 11 2015, 3:26 AM
Krinkle updated the task description. (Show Details)
Krinkle removed a subscriber: gerritbot.

Updated title to reflect actual desired end result. The url structure is secondary and may actually change (see T54281).

Tgr added a subscriber: Tgr.Jun 20 2015, 6:52 PM

When it happens, it'll happen on every wiki. Until then it can't be on any wiki...

A lot of Wikimedia wikis have been happily using VisualEditor for over a year, and the wikitext editor being the default even for new editors is problematic for them. (It is somewhat ridiculous, for example, that SandboxLink, which is mainly meant to make the life of new editors easier, drops them into a wikitext editor.) I don't see what's wrong with providing a per-wiki option.

Hi folks! Just in case the duplicate doesn't speak by itself, I see no reason why we don't have right now:

A project that has visual editor as default for everybody, even unauthenticated users, should open red links with the visual editor.

All other projects should wait until you sort out the mess with picking the right editor for each user.

This is definitely not hard to implement, there's not even a new config involved.

Cheers and thanks for looking into this.

Tgr added a comment.Jun 29 2015, 9:54 PM

A project that has visual editor as default for everybody, even unauthenticated users, should open red links with the visual editor.

A gadget (enabled by default) which replaces action=edit with veaction=edit might be the easiest short-term solution - it gives the ability to opt out, and does not cause cache fragmentation.

A project that has visual editor as default for

Sorry, but this is not a thing. MediaWiki does not let you set default=wikitext vs. default=visualeditor. You get given one editor by MediaWiki for wikitext, and it's what gets shown at action=edit (the target of all of MediaWiki's red links). VE hacks itself in via veaction=edit, but this cannot be considered a default by any means.

TTO added a comment.Jul 6 2015, 6:17 AM

@Krenair I'm a little puzzled by your comment:

Sorry, but this is not a thing. MediaWiki does not let you set default=wikitext vs. default=visualeditor. You get given one editor by MediaWiki for wikitext, and it's what gets shown at action=edit (the target of all of MediaWiki's red links).

Well, isn't that part of the point of this issue - to make redlinks configurable? Of course, T102398 would render that moot, but in the interim, I have uploaded new patch sets to https://gerrit.wikimedia.org/r/178817 that allow extensions to retarget redlinks.

I don't expect WMF wikis to use this, but some third-party installations are interested in it (judging by posts at Support Desk over the past few months).

Indeed, this bug is not about action=edit but about what gets linked most prominently. Red links are the single most important entry point for article editing after the edit tabs and section editing, so it makes sense to make them smarter/configurable.

Then of course there are many other links to handle later (think of inputbox and so on) but divide et impera applies.

Red links are the single most important entry point for article editing after the edit tabs and section editing, so it makes sense to make them smarter/configurable.

I've been wondering how are articles created. Is it red links from other articles? The red links that appears when search for a page that doesn't exist? Something else?

When it happens, it'll happen on every wiki. Until then it can't be on any wiki...

So, why it was told to me, we need a community consensus?! Dont tell me that it cannot be set differently to each project?!

TTO added a comment.Jul 7 2015, 10:52 AM

So, why it was told to me, we need a community consensus?! Dont tell me that it cannot be set differently to each project?!

At the moment, it cannot, because the feature you are asking for doesn't even exist yet. That is the problem we are trying to solve with the patch linked above.

Once that is dealt with, then we can potentially act upon the community consensus and enable the feature on that wiki, if the VE boffins agree that it is a good thing to do.

I'm not sure we want to use this hook for VE. We'd like to have a single edit tab (pointing to action=edit) where the user can chose between VE and a wikitext source editor instead, so this would be obsolete.

We'd like to have a single edit tab where the user can chose between VE and a wikitext source editor

https://meta.wikimedia.org/wiki/Wikiafication

Please, this bug is not about having a single edit tab, or choice, or wikiafication or whatever.

This bug is about making the default choice of editor consistent. For red links. It's that simple.

We'd like to have a single edit tab where the user can chose between VE and a wikitext source editor

https://meta.wikimedia.org/wiki/Wikiafication

This comment is at best unfair and at worst willful ignorance or trolling. Being able to switch between editors while editing has been requested repeatedly, and using the action=edit view for editors is the obvious choice, already made by others such as CodeEditor. It is the most obvious, most intuitive and best way to present two or more editors, and not "additional and costly bloat to a site as an unsuccessful means of "engaging visitors" or "building community"", like that page states.

This bug is about making the default choice of editor consistent. For red links. It's that simple.

I understand. The current situation is poor for the majority of people who click 'edit' rather than 'edit source' and get VE rather than WT, except when it comes to red links.

However, just blindly changing these from WT to VE would be a bad move for a few reasons:

  • It's a pretty core disruptive change to a core part of how MediaWiki works, which means it would probably break a number of scripts, gadgets, bots and other tools that have been built over the past 15 years relying on this being a certain way.
  • It would take a long time to roll out in Wikimedia production, as this would be a breaking change to the read HTML with hrefs' targets being changed, meaning the benefit for IPs would take many weeks to be fully felt (and likely breaking other things).
  • It would replace the bad system (use WT, no choice) with another bad system (use VE, no choice), rather than a 'proper' system of user choice
  • It would be particularly disruptive for 'power editors', who would be forced to switch over to WT every time they clicked edit, likely leading them to opt-out of VE in huge numbers.
  • It would be inconsistent – for namespaces which are WT-only, like MediaWiki: or Template:, would it take you to WT anyway?
  • For users who can't use VE (e.g. no JS, something we can't fix server-side), it would strand them on the 'read' page, rather than take then to WT

Consequently, I am not willing to make this change before we have a single edit tab that solves (or obviates) each of these issues.

TTO added a comment.Jul 11 2015, 1:32 AM

Many of the MW installations that have requested this appear to be corporate/internal wikis. Would you be willing to provide the feature for them, even if you do not enable it on WMF wikis?

In T55441#1446955, @TTO wrote:

Many of the MW installations that have requested this appear to be corporate/internal wikis. Would you be willing to provide the feature for them, even if you do not enable it on WMF wikis?

Yes, that's fine (though ideally we'd do so in a way that doesn't create technical debt in MediaWiki which we'd have to carry).

Nemo_bis removed a subscriber: Nemo_bis.Jul 11 2015, 7:14 AM

We'd like to have a single edit tab where the user can chose between VE and a wikitext source editor

https://meta.wikimedia.org/wiki/Wikiafication

This comment is at best unfair and at worst willful ignorance or trolling. Being able to switch between editors while editing has been requested repeatedly, and using the action=edit view for editors is the obvious choice, already made by others such as CodeEditor. It is the most obvious, most intuitive and best way to present two or more editors

It proves that the essay is biased and Wikiafication can be good sometimes.

Catrope removed a subscriber: Catrope.Jan 14 2016, 7:38 PM

(Only fixed for Single Edit Tab wikis.)

Johan added a subscriber: Johan.Feb 18 2016, 12:25 PM

So does this affect any other wikis than the test wiki at the moment? Hungarian Wikipedia is supposed to get the single edit tab, but doesn't have it yet, right?

Johan added a comment.EditedFeb 18 2016, 3:38 PM

Something like this:

"In the future, clicking a red link will open the page in your primary editor. Today it will open it the wikitext editor. This will only work for wikis with [[<tvar|set>mw:Special:MyLanguage/VisualEditor/Single edit tab</>|single edit tab]]."

(I know the change is happening now, but unless it actually affects editors because it only works for wikis with the single edit tab, it's still a future change for them.)

Something like this:

"In the future, clicking a red link will open the page in your primary editor. Today it will open it the wikitext editor. This will only work for wikis with [[<tvar|set>mw:Special:MyLanguage/VisualEditor/Single edit tab</>|single edit tab]]."

(I know the change is happening now, but unless it actually affects editors because it only works for wikis with the single edit tab, it's still a future change for them.)

The wording looks good. I'd push this to next week, and talk about how it will (then) be live on huwiki and people can see it there.

Johan added a comment.Feb 18 2016, 6:13 PM

Makes sense. I'll do that.

Cirdan added a subscriber: Cirdan.Dec 7 2016, 10:39 AM